;$Id: readasd.pro,v 1.1 2002/04/23 14:47:01 jmspark Exp $
pro readasd,file_name,data,xtitle=xtt,ytitle=ytt,ct=ct
;____________________________________________________________________
;|								    |
;| Purpose	: Read ASD data file of the format which is produced|
;|		  by the NIST neutron spectrometer controle program |
;|		  ICP  const-Q or const-I buffer		    |
;|								    |
;|								    |
;| Input	: file_name, the file to be read		    |
;| Output	: data, the data structure			    |
;| externals	: gendast, to generate data structure		    |
;|								    |
;|__________________________________________________________________|

junk	=	''

openr,lun,file_name(0),/get_lun
;________________________________________________
;|						|
;| read in header data for of the 1st line 	|
;|______________________________________________|

readf,lun,junk
junk		=	strtrim(junk,2)
scan		=	strmid(junk,36,1)
jm0		=	strmid(junk,0,8)
jm1		=	strmid(junk,17,8)
free_lun,lun

if (scan eq 'Q') or (scan eq 'T') then 				$
rasdq,file_name,data,xtitle=xtt,ytitle=ytt,ct=ct		$
else if scan eq 'I' then					$
rasda,file_name,data,xtitle=xtt,ytitle=ytt			$
else if scan eq 'B' then					$
rasdb,file_name,data,xtitle=xtt,ytitle=ytt			$
else print,' Data file type not recognized. Has format changed ?' $
		+' (FROM rnist)'

end

