;$Id: trifenestra_binningbase.pro,v 1.1 2002/07/05 17:59:50 amunter Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::xrebin, event

	wIDx = 'xrebin'
	self -> widget_control, wIDx, get_value = xvalue
	wIDy = 'yrebin'
	self -> widget_control, wIDy, get_value = yvalue

	if xvalue le 0 then begin
		xvalue = 1
		self -> widget_control, wIDx, set_value = xvalue
	endif
	if yvalue le 0 then begin
		yvalue = 1
		self -> widget_control, wIDy, set_value = yvalue
	endif
	self.xrebin = xvalue
	self.yrebin = yvalue
	if obj_valid( self.oDaveCopy ) then begin
		void = self.oDave -> set( self.oDaveCopy )
		if self.xrebin ne 1 or self.yrebin ne 1 then begin
			self.oDave -> rebin_grid, group=[ self.xrebin, self.yrebin ]
		endif
		self -> updateImage
	endif

end

pro trifenestra::yrebin, event

	self -> xrebin, event

end

pro trifenestra::xsmooth, event

	self -> widget_control, 'xsmooth', get_value = value
	self.xsmooth = value
	if self.ysmooth le 0 then self.ysmooth = 1
	if obj_valid( self.oDaveCopy ) then begin
		void = self.oDave -> set( self.oDaveCopy )
		self.oDave -> cgrain_old, self.xsmooth, self.ysmooth
		self -> updateImage
	endif

end

pro trifenestra::ysmooth, event

	self -> widget_control, 'ysmooth', get_value = value
	self.ysmooth = value
	if self.xsmooth le 0 then self.xsmooth = 1
	if obj_valid( self.oDaveCopy ) then begin
		void = self.oDave -> set( self.oDaveCopy )
		self.oDave -> cgrain_old, self.xsmooth, self.ysmooth
		self -> updateImage
	endif

end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra_binningbase, base

bins = widget_base( base, /col, /frame $
	, event_pro = 'trifenestra_event' $
	)

RebinsBase = widget_base( bins, /col )
!trifenestra.self -> widgets,  cw_field( RebinsBase $
	, title = 'X Rebin  ' $
	, value = 1 $
	, uname = 'xrebin' $
	; , /column $
	, /integer $
	, /return_events $
	, uvalue = 'xrebin' $
	, xsize = 10 $
	)


!trifenestra.self -> widgets, cw_field( RebinsBase $
	, title = 'Y Rebin  ' $
	, value = 1 $
	, uname = 'yrebin' $
	; , /column $
	, /integer $
	, /return_events $
	, uvalue = 'yrebin' $
	, xsize = 10 $
	)


Smoothings = widget_base( bins, /col $
	; , event_pro = 'oimageDraw' $
	)

!trifenestra.self -> widgets, cw_field( Smoothings $
	, tit='X Smooth  ' $
	, value=1 $
	, uname = 'xsmooth' $
	, uvalue = 'xsmooth' $
	, /return_events $
	; , /column $
	, xsize = 9 $
	, /integer )


!trifenestra.self -> widgets, cw_field( Smoothings $
	, tit = 'Y Smooth  ' $
	, value=1 $
	, uname = 'ysmooth' $
	, uvalue = 'ysmooth' $
	, /return_events $
	; , /column $
	, xsize = 9 $
	, /integer )

return, bins

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
